      SUBROUTINE FTA3D(ARRAY,N,IREG)
      INTEGER N,IREG,N2P3,N21,I,I1,I2,I3,I4
      DOUBLE PRECISION ARRAY,C1,HALF,C2,WRS,WIS,H1R,H1I,H2R,H2I
      DOUBLE PRECISION WR,WI,WPR,WPI,WTEMP,THETA,SYS003,TWO,ONE
      DIMENSION ARRAY(1)
      DATA SYS003/6.283185307179586D0/,TWO/2.0D0/,HALF/0.5D0/,ONE/1.0D0/
      THETA=SYS003/TWO/DFLOAT(N)
      C1=HALF
      IF(IREG.EQ.1) GO TO 10
      C2=HALF
      THETA=-THETA
      GO TO 20
   10 C2=-HALF
      CALL FTA1P(ARRAY,N,1)
   20 WPR=-TWO*DSIN(HALF*THETA)**2
      WPI=DSIN(THETA)
      WR=ONE+WPR
      WI=WPI
      N2P3=2*N+3
      N21=N/2+1
      DO 30 I=2,N21
      I1=2*I-1
      I2=I1+1
      I3=N2P3-I2
      I4=I3+1
      WRS=WR
      WIS=WI
      H1R=C1*(ARRAY(I1)+ARRAY(I3))
      H1I=C1*(ARRAY(I2)-ARRAY(I4))
      H2R=-C2*(ARRAY(I2)+ARRAY(I4))
      H2I=C2*(ARRAY(I1)-ARRAY(I3))
      ARRAY(I1)=H1R+WRS*H2R-WIS*H2I
      ARRAY(I2)=H1I+WRS*H2I+WIS*H2R
      ARRAY(I3)=H1R-WRS*H2R+WIS*H2I
      ARRAY(I4)=-H1I+WRS*H2I+WIS*H2R
      WTEMP=WR
      WR=WR*WPR-WI*WPI+WR
      WI=WI*WPR+WTEMP*WPI+WI
   30 CONTINUE
      IF(IREG.EQ.1) GO TO 40
      H1R=ARRAY(1)
      ARRAY(1)=C1*(H1R+ARRAY(2))
      ARRAY(2)=C1*(H1R-ARRAY(2))
      CALL FTA1P(ARRAY,N,-1)
      GO TO 50
   40 H1R=ARRAY(1)
      ARRAY(1)=H1R+ARRAY(2)
      ARRAY(2)=H1R-ARRAY(2)
   50 RETURN
      END
